Subject: define() macro

This lets you define a new function in runtime.

With the "override" option you can override preexisting macro functions, but
only macro functions, no action routines nor c functions.

---

 doc/help.etx           |    5 ++
 source/built-ins.h     |    1 
 source/highlightData.c |    2 -
 source/macro.c         |   93 +++++++++++++++++++++++++++++++++++++++++++++++++
 source/parse.y         |    2 -
 5 files changed, 101 insertions(+), 2 deletions(-)

diff --quilt old/source/macro.c new/source/macro.c
--- old/source/macro.c
+++ new/source/macro.c
@@ -3349,6 +3349,99 @@ static int callMS(WindowInfo *window, Da
     return OverlayRoutineFromSymbol(sym, nArgs, 1);
 }
 
+/*
+ * define(func_name, func_body[, "override"])
+ */
+static int defineMS(WindowInfo *window, DataValue *argList, int nArgs,
+        DataValue *result, char **errMsg)
+{
+    char stringStorage[3][TYPE_INT_STR_SIZE(int)];
+    char *name = NULL;
+    char *body = NULL;
+    char *bodysave = NULL;
+    char *stoppedAt = NULL;
+    char *namePtr;
+    char *override = NULL;
+    Program *prog;
+    Symbol *sym;
+
+    if (nArgs < 2 || nArgs > 3) {
+        return wrongNArgsErr(errMsg);
+    }
+    if (!readStringArg(argList[0], &name, stringStorage[0], errMsg)) {
+        return False;
+    }
+    if (!readStringArg(argList[1], &body, stringStorage[1], errMsg)) {
+        return False;
+    }
+    if (nArgs > 2) {
+        if (!readStringArg(argList[2], &override, stringStorage[2], errMsg)) {
+            return False;
+        }
+        if (strcmp(override, "override")) {
+            *errMsg = "Unknown parameter for subroutine %s";
+            return False;
+        }
+    }
+
+    /* check function name */
+    if (strlen(name) > MAX_SYM_LEN ||
+            (!isalpha((unsigned char)name[0]) && !name[0] != '$')) {
+        *errMsg = "subroutine name is not a valid identifier";
+        return False;
+    }
+    namePtr = name + 1;
+    while (isalnum((unsigned char)*namePtr) || *namePtr == '_')
+        namePtr++;
+    if (*namePtr) {
+        *errMsg = "subroutine name is not a valid identifier";
+        return False;
+    }
+
+    /* add a terminating newline */
+    bodysave = XtMalloc(strlen(body) + 2);
+    if (!bodysave) {
+        *errMsg = "Internal error";
+        return False;
+    }
+    strcpy(bodysave, body);
+    strcat(bodysave, "\n");
+
+    /* Parse the macro and report errors if it fails */
+    prog = ParseMacro(bodysave, errMsg, &stoppedAt, False, name);
+    if (!prog) {
+        ParseError(window->macroCmdData ? window->shell : NULL,
+                bodysave, stoppedAt, name, *errMsg);
+        XtFree(bodysave);
+        return False;
+    }
+    XtFree(bodysave);
+
+    sym = LookupSymbol(name);
+    if (sym) {
+        if (!override) {
+            FreeProgram(prog);
+            *errMsg = "Try to override existing function.";
+            return False;
+        } else {
+            if (sym->type != MACRO_FUNCTION_SYM) {
+                FreeProgram(prog);
+                *errMsg = "Try to override a non macro function.";
+                return False;
+            }
+            FreeProgram(sym->value.val.prog);
+            sym->value.val.prog = prog;
+        }
+    } else {
+        DataValue subrPtr;
+        subrPtr.tag = NO_TAG;
+        subrPtr.val.prog = prog;
+        sym = InstallSymbol(name, MACRO_FUNCTION_SYM, subrPtr);
+    }
+
+    return True;
+}
+
 /* T Balinski */
 static int listDialogMS(WindowInfo *window, DataValue *argList, int nArgs,
       DataValue *result, char **errMsg)
diff --quilt old/source/highlightData.c new/source/highlightData.c
--- old/source/highlightData.c
+++ new/source/highlightData.c
@@ -551,7 +551,7 @@ static char *DefaultPatternSets[] = {
         Built-in Misc Vars:\"(?<!\\Y)\\$(?:active_pane|calltip_ID|column|cursor|display_width|empty_array|file_name|file_path|language_mode|line|locked|max_font_width|min_font_width|modified|n_display_lines|n_panes|rangeset_list|read_only|selection_(?:start|end|left|right)|server_name|text_length|top_line|transient|VERSION|NEDIT_HOME)>\":::Identifier::\n\
         Built-in Pref Vars:\"(?<!\\Y)\\$(?:auto_indent|em_tab_dist|file_format|font_name|font_name_bold|font_name_bold_italic|font_name_italic|highlight_syntax|incremental_backup|incremental_search_line|make_backup_copy|match_syntax_based|overtype_mode|show_line_numbers|show_matching|statistics_line|tab_dist|use_tabs|wrap_margin|wrap_text)>\":::Identifier2::\n\
         Built-in Special Vars:\"(?<!\\Y)\\$(?:args|[1-9]|list_dialog_button|n_args|read_status|search_end|shell_cmd_status|string_dialog_button|sub_sep)>\":::String1::\n\
-        Built-in Subrs:\"<(?:args|append_file|beep|call|calltip|clipboard_to_string|dialog|filename_dialog|dict_(?:insert|complete|save|append|is_element)|focus_window|get_character|get_matching|get_pattern_(by_name|at_pos)|get_range|get_selection|get_style_(by_name|at_pos)|getenv|highlight_calltip_line|kill_calltip|length|list_dialog|max|min|n_args|rangeset_(?:add|create|destroy|get_by_name|includes|info|invert|range|set_color|set_mode|set_name|subtract)|read_file|replace_in_string|replace_range|replace_selection|replace_substring|search|search_string|select|select_rectangle|set_cursor_pos|set_transient|shell_command|split|string_compare|string_dialog|string_to_clipboard|substring|t_print|tolower|toupper|valid_number|write_file)(?=\\s*\\()\":::Subroutine::\n\
+        Built-in Subrs:\"<(?:args|append_file|beep|call|calltip|clipboard_to_string|define|dialog|filename_dialog|dict_(?:insert|complete|save|append|is_element)|focus_window|get_character|get_matching|get_pattern_(by_name|at_pos)|get_range|get_selection|get_style_(by_name|at_pos)|getenv|highlight_calltip_line|kill_calltip|length|list_dialog|max|min|n_args|rangeset_(?:add|create|destroy|get_by_name|includes|info|invert|range|set_color|set_mode|set_name|subtract)|read_file|replace_in_string|replace_range|replace_selection|replace_substring|search|search_string|select|select_rectangle|set_cursor_pos|set_transient|shell_command|split|string_compare|string_dialog|string_to_clipboard|substring|t_print|tolower|toupper|valid_number|write_file)(?=\\s*\\()\":::Subroutine::\n\
         Menu Actions:\"<(?:new(?:_tab|_opposite)?|open|open-dialog|open_dialog|open-selected|open_selected|close|save|save-as|save_as|save-as-dialog|save_as_dialog|revert-to-saved|revert_to_saved|revert_to_saved_dialog|include-file|include_file|include-file-dialog|include_file_dialog|load-macro-file|load_macro_file|load-macro-file-dialog|load_macro_file_dialog|load-tags-file|load_tags_file|load-tags-file-dialog|load_tags_file_dialog|unload_tags_file|load_tips_file|load_tips_file_dialog|unload_tips_file|print|print-selection|print_selection|exit|undo|redo|delete|select-all|select_all|shift-left|shift_left|shift-left-by-tab|shift_left_by_tab|shift-right|shift_right|shift-right-by-tab|shift_right_by_tab|find|find-dialog|find_dialog|find-again|find_again|find-selection|find_selection|find_incremental|start_incremental_find|replace|replace-dialog|replace_dialog|replace-all|replace_all|replace-in-selection|replace_in_selection|replace-again|replace_again|replace_find|replace_find_same|replace_find_again|goto-line-number|goto_line_number|goto-line-number-dialog|goto_line_number_dialog|goto-selected|goto_selected|mark|mark-dialog|mark_dialog|goto-mark|goto_mark|goto-mark-dialog|goto_mark_dialog|match|select_to_matching|goto_matching|find-definition|find_definition|show_tip|split-pane|split_pane|close-pane|close_pane|detach_document(?:_dialog)?|move_document_dialog|(?:next|previous|last)_document|uppercase|lowercase|fill-paragraph|fill_paragraph|control-code-dialog|control_code_dialog|filter-selection-dialog|filter_selection_dialog|filter-selection|filter_selection|execute-command|execute_command|execute-command-dialog|execute_command_dialog|execute-command-line|execute_command_line|shell-menu-command|shell_menu_command|macro-menu-command|macro_menu_command|bg_menu_command|post_window_bg_menu|post_tab_context_menu|beginning-of-selection|beginning_of_selection|end-of-selection|end_of_selection|repeat_macro|repeat_dialog|raise_window|focus_pane|set_statistics_line|set_incremental_search_line|set_show_line_numbers|set_auto_indent|set_wrap_text|set_wrap_margin|set_highlight_syntax|set_make_backup_copy|set_incremental_backup|set_show_matching|set_match_syntax_based|set_overtype_mode|set_locked|set_tab_dist|set_em_tab_dist|set_use_tabs|set_fonts|set_language_mode)(?=\\s*\\()\":::Subroutine::\n\
         Text Actions:\"<(?:self-insert|self_insert|grab-focus|grab_focus|extend-adjust|extend_adjust|extend-start|extend_start|extend-end|extend_end|secondary-adjust|secondary_adjust|secondary-or-drag-adjust|secondary_or_drag_adjust|secondary-start|secondary_start|secondary-or-drag-start|secondary_or_drag_start|process-bdrag|process_bdrag|move-destination|move_destination|move-to|move_to|move-to-or-end-drag|move_to_or_end_drag|end_drag|copy-to|copy_to|copy-to-or-end-drag|copy_to_or_end_drag|exchange|process-cancel|process_cancel|paste-clipboard|paste_clipboard|copy-clipboard|copy_clipboard|cut-clipboard|cut_clipboard|copy-primary|copy_primary|cut-primary|cut_primary|newline|newline-and-indent|newline_and_indent|newline-no-indent|newline_no_indent|delete-selection|delete_selection|delete-previous-character|delete_previous_character|delete-next-character|delete_next_character|delete-previous-word|delete_previous_word|delete-next-word|delete_next_word|delete-to-start-of-line|delete_to_start_of_line|delete-to-end-of-line|delete_to_end_of_line|forward-character|forward_character|backward-character|backward_character|key-select|key_select|process-up|process_up|process-down|process_down|process-shift-up|process_shift_up|process-shift-down|process_shift_down|process-home|process_home|forward-word|forward_word|backward-word|backward_word|forward-paragraph|forward_paragraph|backward-paragraph|backward_paragraph|beginning-of-line|beginning_of_line|end-of-line|end_of_line|beginning-of-file|beginning_of_file|end-of-file|end_of_file|next-page|next_page|previous-page|previous_page|page-left|page_left|page-right|page_right|toggle-overstrike|toggle_overstrike|scroll-up|scroll_up|scroll-down|scroll_down|scroll_left|scroll_right|scroll-to-line|scroll_to_line|select-all|select_all|deselect-all|deselect_all|focusIn|focusOut|process-return|process_return|process-tab|process_tab|insert-string|insert_string|mouse_pan)(?=\\s*\\()\":::Subroutine::\n\
         Macro Hooks:\"<(?:(?:pre|post)_(?:open|save)|cursor_moved|modified|(?:losing_)?focus|language_mode)_hook(?=\\s*\\()\":::Subroutine1::\n\
diff --quilt old/doc/help.etx new/doc/help.etx
--- old/doc/help.etx
+++ new/doc/help.etx
@@ -2689,6 +2689,11 @@ Macro Subroutines
   Returns the contents of the clipboard as a macro string. Returns empty
   string on error.
 
+**define( name, body [, "override"] )**
+  Defines a new function with name ~name~ and the macro code in ~body~.
+  If the ~"override"~ option is given the new symbol overrides previously
+  defined functions.
+
 **dialog( message, btn_1_label, btn_2_label, ... )**
   Pop up a dialog for querying and presenting information to the user. First
   argument is a string to show in the message area of the dialog.
diff --quilt old/source/parse.y new/source/parse.y
--- old/source/parse.y
+++ new/source/parse.y
@@ -951,7 +951,7 @@ static int yylex(void)
             if (!strcmp(symName, "in")) return IN;
             if (!strcmp(symName, "$args")) return ARG_LOOKUP;
             if (!strcmp(symName, "delete") && follow_non_whitespace('(', SYMBOL, DELETE) == DELETE) return DELETE;
-            if (!strcmp(symName, "define")) return DEFINE;
+            if (!strcmp(symName, "define") && follow_non_whitespace('(', SYMBOL, DEFINE) == DEFINE) return DEFINE;
             if (!strcmp(symName, "typeof")) return TYPEOF;
             if (nextSymIsField) {
                 nextSymIsField = 0;
diff --quilt old/source/built-ins.h new/source/built-ins.h
--- old/source/built-ins.h
+++ new/source/built-ins.h
@@ -68,6 +68,7 @@ MS(dict_complete, dictcomplete)
 MS(dict_save, dictsave)
 MS(dict_append, dictappend)
 MS(dict_is_element, dictiselement)
+MS(define, define)
 
 MV(cursor, cursor)
 MV(line, line)
